From 16aa2feaaf291b44afc1eb8772f02610ee4fc483 Mon Sep 17 00:00:00 2001
From: Fabio Ritrovato <exsephiroth87@gmail.com>
Date: Sat, 16 Jan 2010 21:48:39 +0100
Subject: [PATCH] [GSoC] luasd: the script loading module

---
 modules/misc/lua/Modules.am           |    1 +
 modules/misc/lua/services_discovery.c |  146 +++++++++++++++++++++++++++++++++
 modules/misc/lua/vlc.c                |   65 ++++++++++++++-
 modules/misc/lua/vlc.h                |    3 +
 4 files changed, 214 insertions(+), 1 deletions(-)
 create mode 100644 modules/misc/lua/services_discovery.c

diff --git a/modules/misc/lua/Modules.am b/modules/misc/lua/Modules.am
index 22aa829..79907bb 100644
--- a/modules/misc/lua/Modules.am
+++ b/modules/misc/lua/Modules.am
@@ -2,6 +2,7 @@ SOURCES_lua = \
 	intf.c \
 	meta.c \
 	demux.c \
+	services_discovery.c \
 	vlc.c \
 	vlc.h \
 	libs.h \
diff --git a/modules/misc/lua/services_discovery.c b/modules/misc/lua/services_discovery.c
new file mode 100644
index 0000000..73b975e
--- /dev/null
+++ b/modules/misc/lua/services_discovery.c
@@ -0,0 +1,146 @@
+/*****************************************************************************
+ * services_discovery.c : Services discovery using lua scripts
+ *****************************************************************************
+ * Copyright (C) 2009 the VideoLAN team
+ *
+ * Authors: Fabio Ritrovato <exsephiroth87@gmail.com>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include <vlc_common.h>
+#include <vlc_services_discovery.h>
+#include <vlc_playlist.h>
+
+#include "vlc.h"
+#include "libs.h"
+
+/*****************************************************************************
+ * Local prototypes
+ *****************************************************************************/
+static void *Run( void * );
+
+/*****************************************************************************
+ * Local structures
+ *****************************************************************************/
+struct services_discovery_sys_t
+{
+    lua_State *L;
+    char *psz_filename;
+    vlc_thread_t thread;
+};
+static const luaL_Reg p_reg[] = { { NULL, NULL } };
+
+/*****************************************************************************
+ * Open: initialize and create stuff
+ *****************************************************************************/
+int Open_LuaSD( vlc_object_t *p_this )
+{
+    services_discovery_t *p_sd = ( services_discovery_t * )p_this;
+    services_discovery_sys_t *p_sys;
+    lua_State *L;
+
+    if( !( p_sys = malloc( sizeof( services_discovery_sys_t ) ) ) )
+        return VLC_ENOMEM;
+    p_sd->p_sys = p_sys;
+    if( asprintf( &p_sys->psz_filename,
+                  "%s" DIR_SEP "lua" DIR_SEP "sd" DIR_SEP "%s.lua",
+                   config_GetUserDir( VLC_DATA_DIR ), p_sd->psz_name ) < 0 )
+    {
+        free( p_sys );
+        return VLC_ENOMEM;
+    }
+    L = luaL_newstate();
+    if( !L )
+    {
+        msg_Err( p_sd, "Could not create new Lua State" );
+        free( p_sys->psz_filename );
+        free( p_sys );
+        return VLC_EGENERIC;
+    }
+    luaL_openlibs( L );
+    luaL_register( L, "vlc", p_reg );
+    lua_pushlightuserdata( L, p_sd );
+    lua_setfield( L, -2, "private" );
+    luaopen_input( L );
+    luaopen_msg( L );
+    luaopen_misc( L );
+    luaopen_net( L );
+    luaopen_object( L );
+    luaopen_playlist( L );
+    luaopen_sd( L );
+    luaopen_strings( L );
+    luaopen_variables( L );
+    luaopen_stream( L );
+    lua_pop( L, 1 );
+    if( luaL_dofile( L, p_sys->psz_filename ) )
+    {
+
+        msg_Err( p_sd, "Error loading script %s: %s", p_sys->psz_filename,
+                  lua_tostring( L, lua_gettop( L ) ) );
+        lua_pop( L, 1 );
+        free( p_sys->psz_filename );
+        free( p_sys );
+        return VLC_EGENERIC;
+    }
+    p_sys->L = L;
+    if( vlc_clone (&p_sd->p_sys->thread, Run, p_sd, VLC_THREAD_PRIORITY_LOW) )
+    {
+        free( p_sys->psz_filename );
+        free( p_sys );
+        return VLC_EGENERIC;
+    }
+    return VLC_SUCCESS;
+}
+
+/*****************************************************************************
+ * Close: cleanup
+ *****************************************************************************/
+void Close_LuaSD( vlc_object_t *p_this )
+{
+    services_discovery_t *p_sd = ( services_discovery_t * )p_this;
+
+    vlc_cancel (p_sd->p_sys->thread);
+    vlc_join (p_sd->p_sys->thread, NULL);
+    free( p_sd->p_sys->psz_filename );
+    lua_close( p_sd->p_sys->L );
+    free( p_sd->p_sys );
+}
+
+/*****************************************************************************
+ * Run: Thread entry-point
+ ****************************************************************************/
+static void* Run( void *data )
+{
+    services_discovery_t *p_sd = ( services_discovery_t * )data;
+    services_discovery_sys_t *p_sys = p_sd->p_sys;
+    lua_State *L = p_sys->L;
+
+    lua_getglobal( L, "main" );
+    if( !lua_isfunction( L, lua_gettop( L ) ) || lua_pcall( L, 0, 1, 0 ) )
+    {
+        msg_Err( p_sd, "Error while runing script %s, "
+                  "function main(): %s", p_sys->psz_filename,
+                  lua_tostring( L, lua_gettop( L ) ) );
+        lua_pop( L, 1 );
+        return NULL;
+    }
+    msg_Info( p_sd, "LuaSD script loaded: %s", p_sd->psz_name );
+    return NULL;
+}
diff --git a/modules/misc/lua/vlc.c b/modules/misc/lua/vlc.c
index 6173b7c..9c1b411 100644
--- a/modules/misc/lua/vlc.c
+++ b/modules/misc/lua/vlc.c
@@ -40,6 +40,7 @@
 #include <vlc_meta.h>
 #include <vlc_charset.h>
 #include <vlc_aout.h>
+#include <vlc_services_discovery.h>
 
 #include <lua.h>        /* Low level lua C API */
 #include <lauxlib.h>    /* Higher level C API */
@@ -50,13 +51,14 @@
 /*****************************************************************************
  * Module descriptor
  *****************************************************************************/
-
 #define INTF_TEXT N_("Lua interface")
 #define INTF_LONGTEXT N_("Lua interface module to load")
 
 #define CONFIG_TEXT N_("Lua interface configuration")
 #define CONFIG_LONGTEXT N_("Lua interface configuration string. Format is: '[\"<interface module name>\"] = { <option> = <value>, ...}, ...'.")
 
+static int vlc_sd_probe_Open( vlc_object_t * );
+
 vlc_module_begin ()
         set_shortname( N_( "Lua Art" ) )
         set_description( N_("Fetch artwork using lua scripts") )
@@ -106,6 +108,14 @@ vlc_module_begin ()
         add_string( "lua-config", "", NULL,
                     CONFIG_TEXT, CONFIG_LONGTEXT, false )
         set_callbacks( Open_LuaIntf, Close_LuaIntf )
+
+    add_submodule ()
+        add_shortcut( "luasd" )
+        set_capability( "services_discovery", 0 )
+        set_callbacks( Open_LuaSD, Close_LuaSD )
+
+    VLC_SD_PROBE_SUBMODULE
+
 vlc_module_end ()
 
 /*****************************************************************************
@@ -505,3 +515,56 @@ int __vlclua_playlist_add_internal( vlc_object_t *p_this, lua_State *L,
     }
     return i_count;
 }
+
+static int vlc_sd_probe_Open( vlc_object_t *obj )
+{
+    vlc_probe_t *probe = (vlc_probe_t *)obj;
+    char *psz_file;
+    int    i_dirlen;
+    DIR *  dir;
+    struct dirent * file;
+    char  *ppsz_dir_list[] = { NULL, NULL, NULL, NULL };
+    char **ppsz_dir;
+    vlclua_dir_list( probe, "sd", ppsz_dir_list );
+    for( ppsz_dir = ppsz_dir_list; *ppsz_dir; ppsz_dir++ )
+    {
+        dir = opendir( *ppsz_dir );
+        if( dir )
+        {
+            i_dirlen = strlen( *ppsz_dir );
+            while( ( file = readdir( dir ) ) )
+            {
+                unsigned int i_len;
+                if( *file->d_name )
+                {
+                    i_len = strlen( file->d_name );
+                    if( !strcmp( file->d_name + ( i_len - 4 ), ".lua" ) )
+                    {
+                        psz_file = malloc( i_dirlen + 1 + i_len + 1 );
+                        sprintf( psz_file, "%s"DIR_SEP"%s", *ppsz_dir,
+                                 file->d_name );
+                        FILE *fd = fopen( psz_file, "r" );
+                        if( fd )
+                        {
+                            char description[256];
+                            if( fgets( description, 256, fd ) != NULL )
+                            {
+                                char *temp = strchr( description, '\n' );
+                                if( temp )
+                                    *temp = '\0';
+                                file->d_name[ i_len - 4 ] = '\0';
+                                vlc_sd_probe_Add( probe, file->d_name,
+                                                  description + 17, "luasd" );
+                            }
+                            fclose( fd );
+                        }
+                        free( psz_file );
+                    }
+                }
+            }
+            closedir( dir );
+        }
+    }
+    vlclua_dir_list_free( ppsz_dir_list );
+    return VLC_PROBE_CONTINUE;
+}
diff --git a/modules/misc/lua/vlc.h b/modules/misc/lua/vlc.h
index 1e23233..53d8593 100644
--- a/modules/misc/lua/vlc.h
+++ b/modules/misc/lua/vlc.h
@@ -54,6 +54,9 @@ void Close_LuaPlaylist( vlc_object_t * );
 int Open_LuaIntf( vlc_object_t * );
 void Close_LuaIntf( vlc_object_t * );
 
+int Open_LuaSD( vlc_object_t * );
+void Close_LuaSD( vlc_object_t * );
+
 
 /*****************************************************************************
  * Lua debug
-- 
1.6.0.4